#include "bt.h"

/*------------------------------------------------------------------------
 * recvheader - when we know a btmsg is coming, receive and parse the header
 *------------------------------------------------------------------------
 */
int recvheader (btintmsg *header, int sock) {

	char buf[BUFSIZ];
	int bytescopied=0;
	int count;
	char message[MSGHEADERSIZ];

	do {
		count = read(sock, buf, MSGHEADERSIZ);
		logaudit("recvheader: reading header, count is: %d\n", count);
		if (count <= 0) {
			logaudit("recvheader: %s\n", strerror(errno));
			return -1;
		}
		memcpy (&message[bytescopied], buf, count);	
		bytescopied+=count;	
		(void) pthread_mutex_lock(&stats.st_mutex);
		stats.st_bytecount += count;
		(void) pthread_mutex_unlock(&stats.st_mutex); 
	} while (bytescopied < MSGHEADERSIZ);

	/*we have received the header*/
	logaudit("recvheader: header is: %.*s\n", bytescopied, message);
	memcpy(header->filename, message, FILENAMESIZ);
	header->filename[FILENAMESIZ]=0;
	logaudit("recvheader: header filename is: %s.\n", header->filename);
	memcpy(header->msgtype, &message[FILENAMESIZ], MSGTYPESIZ);
	header->msgtype[MSGTYPESIZ]=0;
	logaudit("recvheader: header msgtype is: %s.\n", header->msgtype);
	memcpy(header->chunkno, &message[FILENAMESIZ+MSGTYPESIZ], CHUNKNOSIZ);
	logaudit("recvheader: header chunkno is: %.*s.\n", CHUNKNOSIZ, header->chunkno);
	memcpy(header->chunksize, &message[FILENAMESIZ+MSGTYPESIZ+CHUNKNOSIZ], CHUNKLENGTHSIZ);
	logaudit("recvheader: header.chunksize is %.*s.\n", CHUNKLENGTHSIZ, header->chunksize);
	
	return 0;

}
