#include "bt.h"

/*------------------------------------------------------------------------
 * createmetafile - make a properly-formatted metafile out of a file on disk
 *------------------------------------------------------------------------
 */

int createmetafile(char* filename) {

	int i;
	int bytesread;
	int checksum;
	int byteswritten=0;
	char chunkbuf[CHUNKSIZE];
	int nchunks;
	struct stat fstatbuf;
	int chunkno=0;
	FILE* f2send;
	FILE* f2make;
	char filename2write[strlen(filename) + strlen(METAFILEEXT) + 1];
	struct in_addr host;
	div_t q;

	if((f2send=fopen(filename, "r"))==NULL) {
		logaudit("file %s not found", filename);
	} else {
		logaudit("found file %s\n", filename);

		strcpy(filename2write,filename);	
		strcat(filename2write, METAFILEEXT);
		logaudit("opening filename2write, %s\n", filename2write);
		f2make=fopen(filename2write, "w");

		byteswritten+=fprintf(f2make, "%s\n", filename);
		
		if (stat(filename, &fstatbuf)<0) 
			errexit("stat: %s\n", strerror(errno));

		byteswritten+=fprintf(f2make, "%d\n", fstatbuf.st_size);

		findmyip(&host);

		logaudit("host is %s\n", inet_ntoa(host));
		byteswritten+=fprintf(f2make, "%s\n", inet_ntoa(host));

		byteswritten+=fprintf(f2make, "%d\n", CHUNKSIZE);		

		
		logaudit("fstatbuf.st_size: %d\n", fstatbuf.st_size);
		q=div(fstatbuf.st_size,CHUNKSIZE);
		logaudit("which makes nchunks q.quot+1, %d, with q.rem %d\n", q.quot+1, q.rem);
		byteswritten+=fprintf(f2make, "%d\n", q.quot+1);

		while ((bytesread=fread(chunkbuf, 1, CHUNKSIZE, f2send))>0) {
			byteswritten+=fprintf(f2make, "%d ", chunkno);
			//printf("bytesread (#bytes in this chunk) is: %d\n", bytesread);
			checksum=0;
			for (i=0; i<bytesread; i++) {
				checksum+=chunkbuf[i];
			}
			//printf("checksum sum is %d\n", checksum);
			checksum=checksum%256;
			//printf("checksum%%256 is %d\n", checksum);
			byteswritten+=fprintf(f2make, "%d\n", checksum);
			chunkno++;
		}	
	}

	fclose(f2make);
	fclose(f2send);

	return 0;
}
