/* testbtc.c - testing rig for bt client */

#include "bt.h"

int main() {

	pthread_t	th;
	pthread_attr_t	ta;

	nfiles=0; /* startup value */

 	files = malloc(NUMFILES * sizeof(filedesc));
	memset(files, 0, (NUMFILES * sizeof(filedesc)));

	(void) pthread_attr_init(&ta);
	(void) pthread_attr_setdetachstate(&ta, PTHREAD_CREATE_DETACHED);
	(void) pthread_mutex_init(&stats.st_mutex, 0);
	(void) pthread_mutex_init(&filestate_mutex, 0);

	/*if filestate file exists, load it; otherwise, create a new one*/
	if (access(filestate, F_OK)<0) {
		printf("testbtc: main, no filestate file found, running updatefiles\n");
		updatefiles();
	} else {
		printf("testbtc: main, filestate file found, running loadstate\n");
		loadstate();
		printf("testbtc: main, loadstate complete, running updatefiles\n");
		updatefiles();
	}
	
	printf("testbtc: main, starting thread for prstats\n");
	if (pthread_create(&th, &ta, (void * (*)(void *))prstats, 0) < 0)
		errexit("testbtc: pthread_create(prstats): %s\n", strerror(errno));

	printf("testbtc: main, about to call btc\n");
	btc();

	/* we've created the important threads, so wait forever then return 0 */
	printf("testbtc: main, sleeping forever\n");
	while (1) {
		sleep(13371337);
	}
	printf("testbtc: finished btc\n");
	return 0;
}
